diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
index 84c9e5f2a..651969e94 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureFire extends DynamicTexture{
 	
@@ -9,38 +11,42 @@ public class DynamicTextureFire extends DynamicTexture{
 
 	private int height;
 	private float scaleFactor;
-	
+
+	public DynamicTextureFire(@NotNull IconCoordinate targetTexture) {
+		super(targetTexture);
+	}
+
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:block/fire"));
-		scaleFactor = texture.height / 16.0f;
+		initTexture();
+		scaleFactor = targetTexture.height / 16.0f;
 		
 		height = (int) (20 * scaleFactor);
-		this.arr1 = new float[texture.width * (height + 4)];
-		this.arr2 = new float[texture.width * (height + 4)];
+		this.arr1 = new float[targetTexture.width * (height + 4)];
+		this.arr2 = new float[targetTexture.width * (height + 4)];
 	}
 
 	@Override
 	public void update() {
-		for(int x = 0; x < texture.width; x++) {
+		for(int x = 0; x < targetTexture.width; x++) {
 			for(int y = 0; y < height; y++) {
 				int var3 = (int) (15 * scaleFactor);
 				
-				float bright = this.arr1[x + (y + 1) % height * texture.width] * (float)var3;
+				float bright = this.arr1[x + (y + 1) % height * targetTexture.width] * (float)var3;
 
 				for(int k = x - 1; k <= x + 1; ++k) {
 					for(int l = y; l <= y + 1; ++l) {
-						if(k >= 0 && l >= 0 && k < texture.width && l < height) {
-							bright += this.arr1[k + l * texture.width];
+						if(k >= 0 && l >= 0 && k < targetTexture.width && l < height) {
+							bright += this.arr1[k + l * targetTexture.width];
 						}
 
 						++var3;
 					}
 				}
 
-				this.arr2[x + y * texture.width] = bright / ((float)var3 * (1.0f + (0.06f / scaleFactor)));
+				this.arr2[x + y * targetTexture.width] = bright / ((float)var3 * (1.0f + (0.06f / scaleFactor)));
 				if(y >= 17 * scaleFactor) {
-					this.arr2[x + y * texture.width] = (float)(Math.random() * Math.random() * Math.random() * 4.0D + Math.random() * 0.1 + 0.2);
+					this.arr2[x + y * targetTexture.width] = (float)(Math.random() * Math.random() * Math.random() * 4.0D + Math.random() * 0.1 + 0.2);
 				}
 			}
 		}
@@ -49,7 +55,7 @@ public class DynamicTextureFire extends DynamicTexture{
 		this.arr2 = this.arr1;
 		this.arr1 = _arr2;
 
-		for(int i = 0; i < texture.width * texture.height; ++i) {
+		for(int i = 0; i < targetTexture.width * targetTexture.height; ++i) {
 			float l = this.arr1[i] * 1.8F;
 			if(l > 1.0F) {
 				l = 1.0F;
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
index c14c68d6b..2244aeaab 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
@@ -1,8 +1,6 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.MathHelper;
@@ -13,18 +11,14 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
     private final byte[] originalData;
     private long ticks = 0;
 
-	public DynamicTextureFireflyJar(Minecraft mc, String animationSource, String texturePath) {
-		BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(animationSource));
+	public DynamicTextureFireflyJar(IconCoordinate texture) {
+        super(texture);
+		BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(texture.getImageSource()));
 		if(image == null) {
 			throw new TexturePackException("Could not load image!");
 		}
 		this.originalData = new byte[image.getWidth() * image.getHeight() * 4];
 
-		IconCoordinate texture = TextureRegistry.getTexture(texturePath);
-		texture.setDimension(image.getWidth(), image.getHeight());
-		texture.parentAtlas.dontSetSize.add(texture);
-		setTexture(texture);
-		
 		for(int x = 0; x < texture.width; x++) {
 			for(int y = 0; y < texture.height; y++) {
 				putPixel(originalData, y * texture.width + x, image.getRGB(x, y));
@@ -34,7 +28,7 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
 
 	@Override
 	public void postInit() {
-		
+        initTexture();
 	}
 
     private float getInternalBrightness()
@@ -53,16 +47,16 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
         ticks++;
         float br = getInternalBrightness();
 
-        for (int x = 0; x < texture.width; x++){
-            for (int y = 0; y < texture.height; y++)
+        for (int x = 0; x < targetTexture.width; x++){
+            for (int y = 0; y < targetTexture.height; y++)
             {
-                int i = y * texture.width + x;
+                int i = y * targetTexture.width + x;
                 int a = this.originalData[i * 4 + 3] & 0xFF;
                 int r = this.originalData[i * 4 + 0] & 0xFF;
                 int g = this.originalData[i * 4 + 1] & 0xFF;
                 int b = this.originalData[i * 4 + 2] & 0xFF;
 
-                if (x >= texture.width * (6 / 16f) && x < texture.width * (10 / 16f) && y >= texture.height * (6 / 16f) && y < texture.height)
+                if (x >= targetTexture.width * (6 / 16f) && x < targetTexture.width * (10 / 16f) && y >= targetTexture.height * (6 / 16f) && y < targetTexture.height)
                 {
 
                     float rf = r / 255f;
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
index fd6c73dda..1070dc1d8 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureLavaFlowing extends DynamicTexture {
 
@@ -11,14 +13,18 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 	private float[] arr4;
 	private int ticks = 0;
 
+	public DynamicTextureLavaFlowing(@NotNull IconCoordinate targetTexture) {
+		super(targetTexture);
+	}
+
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:block/lava_flowing"));
+		initTexture();
 		
-		arr1 = new float[texture.getArea()];
-		arr2 = new float[texture.getArea()];
-		arr3 = new float[texture.getArea()];
-		arr4 = new float[texture.getArea()];
+		arr1 = new float[targetTexture.getArea()];
+		arr2 = new float[targetTexture.getArea()];
+		arr3 = new float[targetTexture.getArea()];
+		arr4 = new float[targetTexture.getArea()];
 	}
 
 	@Override
@@ -32,37 +38,37 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 		int _y;
 		int var8;
 		int var9;
-		for (int x = 0; x < texture.width; ++x) {
-			for (y = 0; y < texture.height; ++y) {
+		for (int x = 0; x < targetTexture.width; ++x) {
+			for (y = 0; y < targetTexture.height; ++y) {
 				var3 = 0.0F;
-				int var4 = (int) (MathHelper.sin((float) y * MathHelper.PI * 2.0F / texture.height) * 1.2F);
-				var5 = (int) (MathHelper.sin((float) x * MathHelper.PI * 2.0F / texture.width) * 1.2F);
+				int var4 = (int) (MathHelper.sin((float) y * MathHelper.PI * 2.0F / targetTexture.height) * 1.2F);
+				var5 = (int) (MathHelper.sin((float) x * MathHelper.PI * 2.0F / targetTexture.width) * 1.2F);
 
 				for (_x = x - 1; _x <= x + 1; ++_x) {
 					for (_y = y - 1; _y <= y + 1; ++_y) {
-						var8 = pmod(_x + var4, texture.width);
-						var9 = pmod(_y + var5, texture.height);
-						var3 += this.arr1[var8 + var9 * texture.width];
+						var8 = pmod(_x + var4, targetTexture.width);
+						var9 = pmod(_y + var5, targetTexture.height);
+						var3 += this.arr1[var8 + var9 * targetTexture.width];
 					}
 				}
 
-				this.arr2[x + y * texture.width] = var3 / 10.0F
-						+ (this.arr3[(pmod(x + 0, texture.width))
-						+ (pmod(y + 0, texture.height)) * texture.width]
-						+ this.arr3[(pmod(x + 1, texture.width))
-						+ (pmod(y + 0, texture.height)) * texture.width]
-						+ this.arr3[(pmod(x + 1, texture.width))
-						+ (pmod(y + 1, texture.height)) * texture.width]
-						+ this.arr3[(pmod(x + 0, texture.width))
-						+ (pmod(y + 1, texture.height)) * texture.width]) / 4.0F * 0.8F;
-				this.arr3[x + y * texture.width] += this.arr4[x + y * texture.width] * 0.01F;
-				if (this.arr3[x + y * texture.width] < 0.0F) {
-					this.arr3[x + y * texture.width] = 0.0F;
+				this.arr2[x + y * targetTexture.width] = var3 / 10.0F
+						+ (this.arr3[(pmod(x + 0, targetTexture.width))
+						+ (pmod(y + 0, targetTexture.height)) * targetTexture.width]
+						+ this.arr3[(pmod(x + 1, targetTexture.width))
+						+ (pmod(y + 0, targetTexture.height)) * targetTexture.width]
+						+ this.arr3[(pmod(x + 1, targetTexture.width))
+						+ (pmod(y + 1, targetTexture.height)) * targetTexture.width]
+						+ this.arr3[(pmod(x + 0, targetTexture.width))
+						+ (pmod(y + 1, targetTexture.height)) * targetTexture.width]) / 4.0F * 0.8F;
+				this.arr3[x + y * targetTexture.width] += this.arr4[x + y * targetTexture.width] * 0.01F;
+				if (this.arr3[x + y * targetTexture.width] < 0.0F) {
+					this.arr3[x + y * targetTexture.width] = 0.0F;
 				}
 
-				this.arr4[x + y * texture.width] -= 0.06F;
+				this.arr4[x + y * targetTexture.width] -= 0.06F;
 				if (java.lang.Math.random() < 0.005D) {
-					this.arr4[x + y * texture.width] = 1.5F;
+					this.arr4[x + y * targetTexture.width] = 1.5F;
 				}
 			}
 		}
@@ -71,8 +77,8 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var11;
 
-		for (int i = 0; i < texture.getArea(); ++i) {
-			var3 = this.arr1[pmod(i - this.ticks / 3 * texture.width, texture.getArea())] * 2.0F;
+		for (int i = 0; i < targetTexture.getArea(); ++i) {
+			var3 = this.arr1[pmod(i - this.ticks / 3 * targetTexture.width, targetTexture.getArea())] * 2.0F;
 			if (var3 > 1.0F) {
 				var3 = 1.0F;
 			}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
index fd28296fe..04eb555ca 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureLavaStill extends DynamicTexture {
 
@@ -10,14 +12,18 @@ public class DynamicTextureLavaStill extends DynamicTexture {
 	private float[] arr3;
 	private float[] arr4;
 
+	public DynamicTextureLavaStill(@NotNull IconCoordinate targetTexture) {
+		super(targetTexture);
+	}
+
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:block/lava_still"));
+		initTexture();
 		
-		arr1 = new float[texture.getArea()];
-		arr2 = new float[texture.getArea()];
-		arr3 = new float[texture.getArea()];
-		arr4 = new float[texture.getArea()];
+		arr1 = new float[targetTexture.getArea()];
+		arr2 = new float[targetTexture.getArea()];
+		arr3 = new float[targetTexture.getArea()];
+		arr4 = new float[targetTexture.getArea()];
 	}
 
 	@Override
@@ -27,38 +33,38 @@ public class DynamicTextureLavaStill extends DynamicTexture {
 		int b;
 		int var8;
 		int var9;
-		for (int i = 0; i < texture.width; ++i) {
-			for (int j = 0; j < texture.height; ++j) {
+		for (int i = 0; i < targetTexture.width; ++i) {
+			for (int j = 0; j < targetTexture.height; ++j) {
 				var3 = 0.0F;
-				int x2 = (int) (MathHelper.sin((float) j * MathHelper.PI * 2.0F / texture.width) * 1.2F);
-				int y2 = (int) (MathHelper.sin((float) i * MathHelper.PI * 2.0F / texture.height) * 1.2F);
+				int x2 = (int) (MathHelper.sin((float) j * MathHelper.PI * 2.0F / targetTexture.width) * 1.2F);
+				int y2 = (int) (MathHelper.sin((float) i * MathHelper.PI * 2.0F / targetTexture.height) * 1.2F);
 
 				for (g = i - 1; g <= i + 1; ++g) {
 					for (b = j - 1; b <= j + 1; ++b) {
-						var8 = pmod(g + x2, texture.width);
-						var9 = pmod(b + y2, texture.height);
-						var3 += this.arr1[var8 + var9 * texture.width];
+						var8 = pmod(g + x2, targetTexture.width);
+						var9 = pmod(b + y2, targetTexture.height);
+						var3 += this.arr1[var8 + var9 * targetTexture.width];
 					}
 				}
 
-				this.arr2[i + j * texture.width] = var3 / 10.0F
-						+ (this.arr3[(pmod(i + 0, texture.width))
-						+ (pmod(j + 0, texture.height)) * texture.width]
-						+ this.arr3[(pmod(i + 1, texture.width))
-						+ (pmod(j + 0, texture.height)) * texture.width]
-						+ this.arr3[(pmod(i + 1, texture.width))
-						+ (pmod(j + 1, texture.height)) * texture.width]
-						+ this.arr3[(pmod(i + 0, texture.width))
-						+ (pmod(j + 1, texture.height)) * texture.width]) / 4.0F * 0.8F;
+				this.arr2[i + j * targetTexture.width] = var3 / 10.0F
+						+ (this.arr3[(pmod(i + 0, targetTexture.width))
+						+ (pmod(j + 0, targetTexture.height)) * targetTexture.width]
+						+ this.arr3[(pmod(i + 1, targetTexture.width))
+						+ (pmod(j + 0, targetTexture.height)) * targetTexture.width]
+						+ this.arr3[(pmod(i + 1, targetTexture.width))
+						+ (pmod(j + 1, targetTexture.height)) * targetTexture.width]
+						+ this.arr3[(pmod(i + 0, targetTexture.width))
+						+ (pmod(j + 1, targetTexture.height)) * targetTexture.width]) / 4.0F * 0.8F;
 				
-				this.arr3[i + j * texture.width] += this.arr4[i + j * texture.width] * 0.01F;
-				if (this.arr3[i + j * texture.width] < 0.0F) {
-					this.arr3[i + j * texture.width] = 0.0F;
+				this.arr3[i + j * targetTexture.width] += this.arr4[i + j * targetTexture.width] * 0.01F;
+				if (this.arr3[i + j * targetTexture.width] < 0.0F) {
+					this.arr3[i + j * targetTexture.width] = 0.0F;
 				}
 
-				this.arr4[i + j * texture.width] -= 0.06F;
+				this.arr4[i + j * targetTexture.width] -= 0.06F;
 				if (java.lang.Math.random() < 0.005D) {
-					this.arr4[i + j * texture.width] = 1.5F;
+					this.arr4[i + j * targetTexture.width] = 1.5F;
 				}
 			}
 		}
@@ -70,7 +76,7 @@ public class DynamicTextureLavaStill extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var11;
 
-		for (i = 0; i < texture.getArea(); ++i) {
+		for (i = 0; i < targetTexture.getArea(); ++i) {
 			var3 = this.arr1[i] * 2.0F;
 			if (var3 > 1.0F) {
 				var3 = 1.0F;
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
index 1fa41e4e5..170bc5cb5 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexturePortal.java
@@ -2,7 +2,8 @@ package net.minecraft.client.render.dynamictexture;
 
 import java.util.Random;
 
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class DynamicTexturePortal extends DynamicTexture{
@@ -11,20 +12,21 @@ public class DynamicTexturePortal extends DynamicTexture{
 	private int portalTickCounter = 0;
 	private byte[][] portalTextureData;
 	
-	public DynamicTexturePortal(boolean altTexture) {
-		this.altTexture = altTexture;
+	public DynamicTexturePortal(IconCoordinate texture, boolean altTexture) {
+        super(texture);
+        this.altTexture = altTexture;
 	}
 
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:block/portal_nether"));
+		initTexture();
 		Random var1 = new Random(100L);
 		
-		portalTextureData = new byte[32][texture.getArea() * 4];
+		portalTextureData = new byte[32][targetTexture.getArea() * 4];
 		
 		for(int i = 0; i < 32; ++i) {
-			for(int x = 0; x < texture.width; ++x) {
-				for(int y = 0; y < texture.height; ++y) {
+			for(int x = 0; x < targetTexture.width; ++x) {
+				for(int y = 0; y < targetTexture.height; ++y) {
 					float f = 0.0F;
 
 					int b;
@@ -35,11 +37,11 @@ public class DynamicTexturePortal extends DynamicTexture{
 							swirlX = 0;
 							swirlY = 0;
 						}else {
-							swirlX = (float)(b * (texture.width / 2));
-							swirlY = (float)(b * (texture.height / 2));
+							swirlX = (float)(b * (targetTexture.width / 2));
+							swirlY = (float)(b * (targetTexture.height / 2));
 						}
-						float var9 = ((float)x - swirlX) / texture.width * 2.0F;
-						float var10 = ((float)y - swirlY) / texture.height * 2.0F;
+						float var9 = ((float)x - swirlX) / targetTexture.width * 2.0F;
+						float var10 = ((float)y - swirlY) / targetTexture.height * 2.0F;
 						if(var9 < -1.0F) {
 							var9 += 2.0F;
 						}
@@ -68,7 +70,7 @@ public class DynamicTexturePortal extends DynamicTexture{
 					int r = (int)(f * f * 200.0F + 55.0F);
 					int g = (int)(f * f * f * f * 255.0F);
 					int a = (int)(f * 100.0F + 155.0F);
-					int l = y * texture.width + x;
+					int l = y * targetTexture.width + x;
 					
 					this.portalTextureData[i][l * 4 + 0] = (byte)r;
 					this.portalTextureData[i][l * 4 + 1] = (byte)g;
@@ -85,7 +87,7 @@ public class DynamicTexturePortal extends DynamicTexture{
 		
 		byte[] var1 = this.portalTextureData[this.portalTickCounter & 31];
 
-		for(int i = 0; i < texture.getArea(); ++i) {
+		for(int i = 0; i < targetTexture.getArea(); ++i) {
 			int r = var1[i * 4 + 0] & 255;
 			int g = var1[i * 4 + 1] & 255;
 			int b = var1[i * 4 + 2] & 255;
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
index ca3dd61b4..fff2e2380 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
@@ -5,7 +5,7 @@ import static net.minecraft.core.util.helper.MathHelper.*;
 import java.awt.image.BufferedImage;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.util.helper.MathHelper;
 
 public abstract class DynamicTextureRotating extends DynamicTexture {
@@ -21,19 +21,19 @@ public abstract class DynamicTextureRotating extends DynamicTexture {
 	protected double delta;
 
 	public DynamicTextureRotating(Minecraft minecraft, IconCoordinate texture) {
+		super(texture);
 		this.mc = minecraft;
-		this.texture = texture;
 	}
 	
 	@Override
 	public void postInit() {
-		setTexture(texture);
+		initTexture();
 
-		BufferedImage atlas = texture.parentAtlas.atlas;
-		clockImageData = new byte[texture.getArea() * 4];
-		for (int x = 0; x < texture.width; x++) {
-			for (int y = 0; y < texture.height; y++) {
-				putPixel(clockImageData, y * texture.width + x, atlas.getRGB(texture.iconX + x, texture.iconY + y));
+		BufferedImage atlas = targetTexture.parentAtlas.atlas;
+		clockImageData = new byte[targetTexture.getArea() * 4];
+		for (int x = 0; x < targetTexture.width; x++) {
+			for (int y = 0; y < targetTexture.height; y++) {
+				putPixel(clockImageData, y * targetTexture.width + x, atlas.getRGB(targetTexture.iconX + x, targetTexture.iconY + y));
 			}
 		}
 	}
@@ -67,9 +67,9 @@ public abstract class DynamicTextureRotating extends DynamicTexture {
 		double x = Math.sin(this.angleFinal);
 		double y = Math.cos(this.angleFinal);
 
-		for (int _x = 0; _x < texture.width; _x++) {
-			for (int _y = 0; _y < texture.height; _y++) {
-				int i = _y * texture.width + _x;
+		for (int _x = 0; _x < targetTexture.width; _x++) {
+			for (int _y = 0; _y < targetTexture.height; _y++) {
+				int i = _y * targetTexture.width + _x;
 				int a = this.clockImageData[i * 4 + 3] & 0xFF;
 				int r = this.clockImageData[i * 4 + 0] & 0xFF;
 				int g = this.clockImageData[i * 4 + 1] & 0xFF;
@@ -80,8 +80,8 @@ public abstract class DynamicTextureRotating extends DynamicTexture {
 				if (r == b && g == 0 && b > 0) {
 					double pixelBrightness = r / 256.0;
 
-					double x2 = -((double) (_x) / (texture.width-1) - 0.5D);
-					double y2 =   (double) (_y) / (texture.height-1) - 0.5D;
+					double x2 = -((double) (_x) / (targetTexture.width-1) - 0.5D);
+					double y2 =   (double) (_y) / (targetTexture.height-1) - 0.5D;
 
 					int x3 = (int) ((x2 * y + y2 * x + 0.5D) * dialTexRes);
 					int y3 = (int) ((y2 * y - x2 * x + 0.5D) * dialTexRes);
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
index be379116b..a4caede0c 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
@@ -3,8 +3,8 @@ package net.minecraft.client.render.dynamictexture;
 import java.awt.image.BufferedImage;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 
 public class DynamicTextureTrommel extends DynamicTextureRotating {
 	
@@ -21,9 +21,9 @@ public class DynamicTextureTrommel extends DynamicTextureRotating {
 	
 	@Override
 	public void postInit() {
-		setTexture(texture);
+		initTexture();
 		
-		BufferedImage atlasImage = texture.parentAtlas.atlas;
+		BufferedImage atlasImage = targetTexture.parentAtlas.atlas;
 		
 		IconCoordinate foreground = TextureRegistry.getTexture("minecraft:block/trommel_active_front_foreground");
 		dialImageData = new byte[foreground.getArea() * 4];
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index 6f60365cd..55d1922e9 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureWaterFlow extends DynamicTexture {
 	
@@ -13,14 +15,18 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 	private float[] arr4;
 	private int ticks = 0;
 
+	public DynamicTextureWaterFlow(@NotNull IconCoordinate targetTexture) {
+		super(targetTexture);
+	}
+
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:block/water_flowing"));
+		initTexture();
 		
-		arr1 = new float[texture.getArea()];
-		arr2 = new float[texture.getArea()];
-		arr3 = new float[texture.getArea()];
-		arr4 = new float[texture.getArea()];
+		arr1 = new float[targetTexture.getArea()];
+		arr2 = new float[targetTexture.getArea()];
+		arr3 = new float[targetTexture.getArea()];
+		arr4 = new float[targetTexture.getArea()];
 	}
 
 	@Override
@@ -28,30 +34,30 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 		this.ticks++;
 
 		float bright;
-		for (int x = 0; x < texture.width; ++x) {
-			for (int y = 0; y < texture.height; ++y) {
+		for (int x = 0; x < targetTexture.width; ++x) {
+			for (int y = 0; y < targetTexture.height; ++y) {
 				bright = 0.0F;
 
 				for (int k = y - 2; k <= y; ++k) {
-					int r = pmod(x, texture.width);
-					int g = pmod(k, texture.height);
-					bright += this.arr1[r + g * texture.width];
+					int r = pmod(x, targetTexture.width);
+					int g = pmod(k, targetTexture.height);
+					bright += this.arr1[r + g * targetTexture.width];
 				}
 
-				this.arr2[x + y * texture.width] = bright / 3.2F + this.arr3[x + y * texture.width] * 0.8F;
+				this.arr2[x + y * targetTexture.width] = bright / 3.2F + this.arr3[x + y * targetTexture.width] * 0.8F;
 			}
 		}
 
-		for (int x = 0; x < texture.width; ++x) {
-			for (int y = 0; y < texture.height; ++y) {
-				this.arr3[x + y * texture.width] += this.arr4[x + y * texture.width] * 0.05F;
-				if (this.arr3[x + y * texture.width] < 0.0F) {
-					this.arr3[x + y * texture.width] = 0.0F;
+		for (int x = 0; x < targetTexture.width; ++x) {
+			for (int y = 0; y < targetTexture.height; ++y) {
+				this.arr3[x + y * targetTexture.width] += this.arr4[x + y * targetTexture.width] * 0.05F;
+				if (this.arr3[x + y * targetTexture.width] < 0.0F) {
+					this.arr3[x + y * targetTexture.width] = 0.0F;
 				}
 
-				this.arr4[x + y * texture.width] -= 0.3F;
+				this.arr4[x + y * targetTexture.width] -= 0.3F;
 				if (Math.random() < 0.2D) {
-					this.arr4[x + y * texture.width] = 0.5F;
+					this.arr4[x + y * targetTexture.width] = 0.5F;
 				}
 			}
 		}
@@ -60,8 +66,8 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var12;
 
-		for (int i = 0; i < texture.getArea(); ++i) {
-			bright = this.arr1[pmod(i - this.ticks * texture.width, texture.getArea())];
+		for (int i = 0; i < targetTexture.getArea(); ++i) {
+			bright = this.arr1[pmod(i - this.ticks * targetTexture.width, targetTexture.getArea())];
 			if (bright > 1.0F) {
 				bright = 1.0F;
 			}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index 1cf3862ec..08ea118e0 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 
 public class DynamicTextureWaterStill extends DynamicTexture {
 	
@@ -12,14 +13,18 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 	private float[] arr3;
 	private float[] arr4;
 
+	public DynamicTextureWaterStill(IconCoordinate targetTexture) {
+		super(targetTexture);
+	}
+
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:block/water_still"));
+		initTexture();
 
-		arr1 = new float[texture.getArea()];
-		arr2 = new float[texture.getArea()];
-		arr3 = new float[texture.getArea()];
-		arr4 = new float[texture.getArea()];
+		arr1 = new float[targetTexture.getArea()];
+		arr2 = new float[targetTexture.getArea()];
+		arr3 = new float[targetTexture.getArea()];
+		arr4 = new float[targetTexture.getArea()];
 	}
 
 	@Override
@@ -28,30 +33,30 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 		float bright;
 		int a_;
 		int b_;
-		for (int x = 0; x < texture.width; ++x) {
-			for (y = 0; y < texture.height; ++y) {
+		for (int x = 0; x < targetTexture.width; ++x) {
+			for (y = 0; y < targetTexture.height; ++y) {
 				bright = 0.0F;
 
 				for (int k = x - 1; k <= x + 1; ++k) {
-					a_ = pmod(k, texture.width);
-					b_ = pmod(y, texture.height);
-					bright += this.arr1[a_ + b_ * texture.width];
+					a_ = pmod(k, targetTexture.width);
+					b_ = pmod(y, targetTexture.height);
+					bright += this.arr1[a_ + b_ * targetTexture.width];
 				}
 
-				this.arr2[x + y * texture.width] = bright / 3.3F + this.arr3[x + y * texture.width] * 0.8F;
+				this.arr2[x + y * targetTexture.width] = bright / 3.3F + this.arr3[x + y * targetTexture.width] * 0.8F;
 			}
 		}
 
-		for (int x = 0; x < texture.width; ++x) {
-			for (y = 0; y < texture.height; ++y) {
-				this.arr3[x + y * texture.width] += this.arr4[x + y * texture.width] * 0.05F;
-				if (this.arr3[x + y * texture.width] < 0.0F) {
-					this.arr3[x + y * texture.width] = 0.0F;
+		for (int x = 0; x < targetTexture.width; ++x) {
+			for (y = 0; y < targetTexture.height; ++y) {
+				this.arr3[x + y * targetTexture.width] += this.arr4[x + y * targetTexture.width] * 0.05F;
+				if (this.arr3[x + y * targetTexture.width] < 0.0F) {
+					this.arr3[x + y * targetTexture.width] = 0.0F;
 				}
 
-				this.arr4[x + y * texture.width] -= 0.1F;
+				this.arr4[x + y * targetTexture.width] -= 0.1F;
 				if (Math.random() < 0.05D) {
-					this.arr4[x + y * texture.width] = 0.5F;
+					this.arr4[x + y * targetTexture.width] = 0.5F;
 				}
 			}
 		}
@@ -60,7 +65,7 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var12;
 
-		for (int i = 0; i < texture.getArea(); ++i) {
+		for (int i = 0; i < targetTexture.getArea(); ++i) {
 			bright = this.arr1[i];
 			if (bright > 1.0F) {
 				bright = 1.0F;
